<?php
define('CONSUMER_SECRET', '1234567890123456789012345678901234567890');
define('GET_TOKEN_URL','https://secure.mixi-platform.com/2/token');
define('GET_FRIENDS_URL', 'http://api.mixi-platform.com/2/people/@me/@friends?fields=@all&count=10000');
define('GRANT_TYPE','authorization_code');

header('Content-type: text/javascript; charset=utf-8');

if(! isset($_GET['callback'], $_GET['consumer_key'], $_GET['code'], $_GET['redirect_url'])) {
  exit(0);
}

if($token_json = getToken(GET_TOKEN_URL, $_GET['consumer_key'], CONSUMER_SECRET, $_GET['code'], $_GET['redirect_url'], GRANT_TYPE)) {
  $token = json_decode($token_json, true);
  if($friends_json = getFriends(GET_FRIENDS_URL, $token['access_token'])) {
    echo $_GET['callback'] . '(' . $friends_json . ')';
  }
}

function getToken($url_base, $consumer_key, $consumer_secret, $code, $redirect_url, $grant_type) {
  $content = array(
    'grant_type' => $grant_type,
    'client_id' => $consumer_key,
    'client_secret' => $consumer_secret,
    'code' => $code,
    'redirect_uri' => $redirect_url
  );
  $options = array('http' => array(
    'method' => 'POST',
    'header' => 'Content-type: application/x-www-form-urlencoded',
    'content' => http_build_query($content)
  ));
  return file_get_contents($url_base, false, stream_context_create($options));
}

function getFriends($url_base, $access_token) {
  $options = array('http' => array(
    'header' => 'Authorization: OAuth ' . $access_token
  ));
  return file_get_contents($url_base, false, stream_context_create($options));
}
?>